"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var InMemoryRepository = function () {
  function InMemoryRepository() {
    var options = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

    _classCallCheck(this, InMemoryRepository);

    this.data = options.defaultData || [];
    this.idCounter = 0;
  }

  _createClass(InMemoryRepository, [{
    key: "getAll",
    value: function getAll() {
      return Promise.resolve(this.data);
    }
  }, {
    key: "get",
    value: function get(id) {
      var data = this.find(id);
      if (data) return Promise.resolve(data);else return Promise.reject(new Error("Data with id " + id + " not found"));
    }
  }, {
    key: "add",
    value: function add(newData) {
      newData.__id = this.idCounter;
      this.idCounter++;
      this.data.push(newData);
      return Promise.resolve(newData);
    }
  }, {
    key: "update",
    value: function update(id, updatedData) {
      var index = this.findIndex(id);
      this.data[index] = updatedData;
      return Promise.resolve();
    }
  }, {
    key: "delete",
    value: function _delete(id) {
      var index = this.findIndex(id);
      this.data.splice(index);
      return Promise.resolve();
    }
  }, {
    key: "find",
    value: function find(id) {
      return this.data.find(function (data) {
        return data.__id === id;
      });
    }
  }, {
    key: "findIndex",
    value: function findIndex(id) {
      return this.data.findIndex(function (data) {
        return data.__id === id;
      });
    }
  }]);

  return InMemoryRepository;
}();

exports.default = InMemoryRepository;